// Tyler Johnson, Noah Pentelovitch, RC Yu
// March 7, 2010
// ME333 Fluff Bot GUI
// Developed from ME 333 Lab 4 code

//add the serial library
import processing.serial.*;
import controlP5.*;

//Initialize GUI
ControlP5 controlP5; // create the handler to allow for controlP5 objects
Textarea commTextarea;

//global variables
int x, y;
int window_height = 700;
int window_width = 800;
// Serial objects
int numPorts = 1;
Serial[] myPorts = new Serial[1];

// button declarations
ImageButtons button_s;
ImageButtons button_t;
ImageButtons button_e;
ImageButtons button_f;
ImageButtons button_p;
ImageButtons button_l;
ImageButtons button_g;
ImageButtons button_r;

void setup() {
  //Window Setup
  size(window_width,window_height);
  frameRate(30);
  background(250);
  
  PImage v;
  v = loadImage("untitled.PNG");
  image(v, 240, 50);
  
  x = y = 0;
    println("Program Started!");
    
    // GUI Setups
    controlP5 = new ControlP5(this); // initialize the GUI controls
    commTextarea = controlP5.addTextarea("Animal","I'm nothing yet", 365,150,100,20);
    commTextarea.setColorBackground(0xff000000);
    
    //Button Setups
    // Define and create image button: Snake
    PImage b = loadImage("base_snake.jpg");
    PImage r = loadImage("roll_snake.jpg");
    PImage d = loadImage("down_snake.jpg");
    x = 180;
    y = 185; 
    int w = b.width;
    int h = b.height;
    char c = 's';
    button_s = new ImageButtons(x, y, w, h, b, r, d, c);
    
    // Define and create image button: Stop
    b = loadImage("base_stop.jpg");
    r = loadImage("base_stop.jpg");
    d = loadImage("down_stop.jpg");
    x = 363;
    y = 426; 
    w = b.width;
    h = b.height;
    c = 'p';
    button_p = new ImageButtons(x, y, w, h, b, r, d, c);
    
    // Define and create image button: Reverse
    b = loadImage("base_reverse.jpg");
    r = loadImage("base_reverse.jpg");
    d = loadImage("down_reverse.jpg");
    x = 355;
    y = 545; 
    w = b.width;
    h = b.height;
    c = 't';
    button_t = new ImageButtons(x, y, w, h, b, r, d, c);
    
    // Define and create image button: Left  
    b = loadImage("base_left.jpg");
    r = loadImage("base_left.jpg");
    d = loadImage("down_left.JPG");
    x = 225;
    y = 420; 
    w = b.width;
    h = b.height;
    c = 'l';
    button_l = new ImageButtons(x, y, w, h, b, r, d, c);
    
    // Define and create image button: Seal  
    b = loadImage("base_seal.jpg");
    r = loadImage("roll_seal.jpg");
    d = loadImage("down_seal.jpg");
    x = 340;
    y = 185; 
    w = b.width;
    h = b.height;
    c = 'e';
    button_e = new ImageButtons(x, y, w, h, b, r, d, c);
    
    // Define and create image button: Fish
    b = loadImage("base_fish.jpg");
    r = loadImage("roll_fish.jpg");
    d = loadImage("down_fish.JPG");
    x = 500;
    y = 185; 
    w = b.width;
    h = b.height;
    c = 'f';
    button_f = new ImageButtons(x, y, w, h, b, r, d, c);

    // Define and create image button: Forward
    b = loadImage("base_forward.JPG");
    r = loadImage("base_forward.JPG");
    d = loadImage("down_forward.JPG");
    x = 355;
    y = 290; 
    w = b.width;
    h = b.height;
    c = 'g';
    button_g = new ImageButtons(x, y, w, h, b, r, d, c);

    // Define and create image button: Right
    b = loadImage("base_right.JPG");
    r = loadImage("base_right.JPG");
    d = loadImage("down_right.JPG");
    x = 480;
    y = 420; 
    w = b.width;
    h = b.height;
    c = 'r';
    button_r = new ImageButtons(x, y, w, h, b, r, d, c);
    
    InitSerial();
}

void draw() {
  button_s.update();
  button_s.display();
  
  button_t.update();
  button_t.display();
  
  button_e.update();
  button_e.display();
  
  button_f.update();
  button_f.display();
  
  button_p.update();
  button_p.display();
  
  button_l.update();
  button_l.display();
  
  button_g.update();
  button_g.display();

  button_r.update();
  button_r.display();
}

// initialize the serial
void InitSerial() {
  // List all the available serial ports
  // you want the one that you plugged in
  println(Serial.list());

  String portList = Serial.list()[1];
  // this assumes the COM port you want is the first one, change the 0 to the place of your comport in the list that appears in the debug window
  myPorts[0] = new Serial(this, portList, 9600);

  // read bytes into a buffer until you get a linefeed (ASCII 10):
  myPorts[0].bufferUntil('\n');
}

// serial event
void serialEvent(Serial thisPort) { 
  // variable to hold the number of the port
  int portNumber = -1;

  // iterate over the list of ports opened, and match the one that generated this event
  for (int p = 0; p < myPorts.length; p++) {
    if (thisPort == myPorts[p]) {
      portNumber = p;
    }
  }

  // read the serial buffer until a newline appears
  String myString = thisPort.readStringUntil('\n');
  myString = trim(myString); // ditch the newline
  println("got: " + myString); // print to debug window
  commTextarea.setText(myString); // put it in the text area
  }// end serialEvent

    class Button
{
  int x, y;
  int w, h;
  color basecolor, highlightcolor;
  color currentcolor;
  boolean over = false;
  boolean pressed = false;   
  
  void pressed() {
    if(over && mousePressed) {
      pressed = true;
      print("sent: "); 
    } else {
      pressed = false;
    }    
  }
  
  boolean overRect(int x, int y, int width, int height) {
  if (mouseX >= x && mouseX <= x+width && 
      mouseY >= y && mouseY <= y+height) {
    return true;
  } else {
    return false;
  }
}
}

class ImageButtons extends Button 
{
  PImage base;
  PImage roll;
  PImage down;
  PImage currentimage;
  char send_char;

ImageButtons(int ix, int iy, int iw, int ih, PImage ibase, PImage iroll, PImage idown, char isend_char) 
  {
    x = ix;
    y = iy;
    w = iw;
    h = ih;
    base = ibase;
    roll = iroll;
    down = idown;
    currentimage = base;
    send_char = isend_char;
  }

void update() 
  {
    over();
    pressed();
    if(pressed) {
      currentimage = down;
      myPorts[0].write(send_char);
      println(send_char);
    } else if (over){
      currentimage = roll;
    } else {
      currentimage = base;
    }
  }
  
void over() 
  {
    if( overRect(x, y, w, h) ) {
      over = true;
    } else {
      over = false;
    }
  }
  
  void display() 
  {
    image(currentimage, x, y);
  }}
